<%@ page
	pageEncoding="UTF-8"
	session="false"
	import="net.sf.basedb.core.User"
	import="net.sf.basedb.core.DbControl"
	import="net.sf.basedb.core.SessionControl"
	import="net.sf.basedb.core.Application"
	import="net.sf.basedb.clients.web.Base"	
	import="net.sf.basedb.clients.web.extensions.ExtensionsControl"
%>
<%@ taglib prefix="base" uri="/WEB-INF/base.tld" %>
<%@ taglib prefix="p" uri="/WEB-INF/path.tld" %>
<%
final SessionControl sc = Base.getExistingSessionControl(request, true);
final String ID = sc.getId();
final float scale = Base.getScale(sc);
final String home = ExtensionsControl.getHomeUrl("net.sf.basedb.labenv.service");
DbControl dc = null;
try
{
	dc = sc.newDbControl();
	final User user = User.getById(dc, sc.getLoggedInUserId());
	%>
<base:page type="popup" title="LabEnv">
<base:head scripts="table.js,ajax.js" styles="table.css" />
	<link rel="stylesheet" type="text/css" href="../css/reggie.css">
	<script language="JavaScript" src="../reggie.js" type="text/javascript" charset="UTF-8"></script>
	<script language="JavaScript" src="boxplot.js" type="text/javascript" charset="UTF-8"></script>
		
		
	<script language="JavaScript">
	var currentStep = 1;
	var debug = false;

	window.onload = function()
	{
		// Create pop-up window from request parameter data
		goCreate();
	};

	function getQueryParameter(parameterName)
	{
		var queryString = window.top.location.search.substring(1);
		var parameterName = parameterName + "=";
		if ( queryString.length > 0 )
		{
			begin = queryString.indexOf(parameterName);
			if (begin != -1)
			{
				begin += parameterName.length;
				end = queryString.indexOf("&" , begin);
				if (end == -1)
				{
					end = queryString.length;
				}
				return unescape(queryString.substring(begin, end));
			}
		}
		return "null";
	}

	function getStorageIntervalInSeconds()
	{
		var storageIntervalInSeconds = 0;
		var labEnvDatabaseConfig = getLabEnvDatabaseConfig();
		if (labEnvDatabaseConfig != null)
		{
			storageIntervalInSeconds = labEnvDatabaseConfig.storageIntervalInSeconds;
		}
		return storageIntervalInSeconds;
	}

	function getLabEnvDatabaseConfig()
	{
		// Get lab environment database configuration JSON object with AJAX
		var frm = document.forms['labenv'];
		var request = Ajax.getXmlHttpRequest();
		var url = '../../labenv.jar/LabEnvironment.servlet?ID=<%=ID%>&cmd=GetLabEnvDatabaseConfig';
		request.open("GET", url, false); 
		request.send(null);
	
		//if (debug) Main.debug(request.responseText);
		//Main.debug(request.responseText);

		var response = JSON.parse(request.responseText);
		if (response.status != 'ok')
		{
			setFatalError(response.message);
			return false;
		}
	
		// Get lab environment database configuration information from the AJAX response
		var labEnvDatabaseConfig = response.labEnvDatabaseConfig;

		return labEnvDatabaseConfig;
	}

	var intervalIsValid = true;

	function fetchSimpleDate(dateStr)
	{
		var simpleDateStr = dateStr;
		if (simpleDateStr != null)
		{
			var blankIndex = simpleDateStr.indexOf(" ");
			if (blankIndex >= 0)
			{
				// YYYYMMDD HHmm or YYYY-MM-DD HH:mm
				// Cut off date string before first space
				simpleDateStr = simpleDateStr.substr(0,blankIndex);
			}
			//alert("simpleDateStr = \"" + simpleDateStr + "\" after removing daytime");
			// YYYYMMDD or YYYY-MM-DD
			var hyphenIndex = simpleDateStr.indexOf("-");
			//alert("simpleDateStr = \"" + simpleDateStr + "\" after removing daytime, hyphenIndex = " + hyphenIndex);
			if (hyphenIndex >= 0)
			{
				// YYYY-MM-DD
				// Cut off date string before first space
				var yearStr = simpleDateStr.substr(0,4);
				var monthStr = simpleDateStr.substr(5,2);
				var dayStr = simpleDateStr.substr(8,2);
				simpleDateStr = yearStr + monthStr + dayStr;
				//alert("simpleDateStr = \"" + simpleDateStr + "\" after removing hyphens, yearStr = \"" + yearStr + "\" monthStr = \"" + monthStr + "\" dayStr = \"" + dayStr + "\"");
			}
		}
		// Date in YYYYMMDD format
		return simpleDateStr;
	}

	function goCreate()
	{
		if (!intervalIsValid) return;
		var frm = document.forms['labenv'];		
		var reportType = 'labenvironmentdailydisplay';		
		Main.hide('gocreate');
		var url = '../LabEnvironmentDisplay.servlet?ID=<%=ID%>&cmd='+reportType;		
		var fromDate = null;
		var chartVariant = null;
		if (chartVariant == null)
		{
			chartVariant = 'http://givare1.onk.lu.se/';
		}
		var pageTitle = getQueryParameter('pageTitle');
		var labSensorUrl = getQueryParameter('labSensorUrl');
		var originDate = getQueryParameter('originDate');
		originDate = fetchSimpleDate(originDate);
		if (originDate != null)
		{
			fromDate = originDate;
		}
		if (labSensorUrl != null)
		{
			chartVariant = labSensorUrl;
		}
		if (pageTitle != null) url += '&pagetitle='+pageTitle;
		if (fromDate != null) url += '&fdate='+fromDate;
		if (chartVariant != null) url += '&cvariant='+chartVariant;

		var request = Ajax.getXmlHttpRequest();
		request.open("GET", url, true);
		Ajax.setReadyStateHandler(request, onPlotGenerated);
		request.send(null);
	}
	
	function onPlotGenerated(request)
	{
		Main.show('reportSection');
		var frm = document.forms['labenv'];		
		var reportType = 'labenvironmentdailydisplay';		
		if (debug) Main.debug(Main.encodeTags(request.responseText));
		var response = JSON.parse(request.responseText);	
		if (response.status != 'ok')
		{
			setFatalError(response.message);
			return false;
		}
		var report = response.report;
		var permissionDeniedForPatientName = report.permissionDeniedForPatientName;
		var pageTitle = report.pageTitle;
		if (pageTitle == null || pageTitle == '')
		{
			pageTitle = 'LabEnv';
		}
		// Print optional page title
		var pageTitleElement = document.getElementById('pageTitleId');
		pageTitleElement.innerHTML = pageTitle;
		var reportTable;
		var cellElement = document.getElementById('reportdiv');
		if (report != null)
		{
			//alert("onPlotGenerated(): Inside plot block for labenvironmentdailydisplay");
			var storageIntervalInSeconds = getStorageIntervalInSeconds();
			var draw_area_wdt = 700;
			var draw_area_hgt = 550;
			var draw_scale_factor = 2;
			var jsonStatisticsPlotArray = report.plotStatistics;
			// Draw plots
			setInnerHTML('reportdiv', '');
			// Write optional page header
			if (pageTitle != null && pageTitle != '')
			{
				// Print optional page headline
				var headlineText = document.createElement('text');
				headlineText.innerHTML = "<h2>" + pageTitle + "</h2><BR>";
				cellElement.appendChild(headlineText);
			}
			for (var plotIndex in jsonStatisticsPlotArray)
			{
				//
				// Get plot JSON data container with extra info and plot data
				var plotJsonDataContainer = jsonStatisticsPlotArray[plotIndex];
				// Get plot JSON extra info and plot data
				var plotChartVariant = plotJsonDataContainer['chartVariant'];
				var plotViewType = plotJsonDataContainer['viewType'];
				var plotOptionalHeadline = plotJsonDataContainer['optionalHeadline'];
				var boxPlotJsonData = plotJsonDataContainer['plotData'];
				// Create plot from plot JSON data
				if (plotOptionalHeadline != null && plotOptionalHeadline != '')
				{
					// Print optional headline
					var headlineText = document.createElement('text');
					headlineText.innerHTML = "<BR>" + plotOptionalHeadline + "<BR>";
					cellElement.appendChild(headlineText);
				}
				var plotKey = plotChartVariant + '_' + plotViewType;
				// Add plot
				var canvasInTable = document.createElement('canvas');
				canvasInTable.setAttribute('id', plotKey);
				canvasInTable.setAttribute('width', draw_area_wdt * draw_scale_factor);
				canvasInTable.setAttribute('height', draw_area_hgt * draw_scale_factor);
				createGraphPlot(boxPlotJsonData, canvasInTable, draw_area_wdt, draw_area_hgt, draw_scale_factor, plotViewType, storageIntervalInSeconds);
				cellElement.appendChild(canvasInTable);					
				canvasInTable.addEventListener('mousemove', drawCanvasGuidelines, false);
				canvasInTable.addEventListener('mouseleave', hideCanvasGuidelines, false);
			}
			// Print optional appended info
			var appendedInfo = report.appendedInfo;
			if (appendedInfo != null && appendedInfo != '')
			{
				// Print optional headline
				var infoText = document.createElement('text');
				infoText.innerHTML = "<BR>" + appendedInfo + "<BR>";
				cellElement.appendChild(infoText);
			}
		}
		else
		{
			var messageCell = getTableCellElement(document, 'No values could be found during given period', 'reportheader');
			var messageRow = document.createElement('tr');
			messageRow.appendChild(messageCell);			
			var messageTable = getReportTable();
			messageTable.appendChild(messageRow);
			reportTable = messageTable;			
		}
		Main.show('printButton');
		Main.show('gorestart');		
	}

	function getJSONData(jsonObject, key)
	{
		var data = getJSONData(jsonObject, key, '');
		return data;
	}

	function getJSONData(jsonObject, key, defaultChoice)
	{
		var data = defaultChoice;
		if (jsonObject != null)
		{
			if (jsonObject[key] != null)
			{
				data = jsonObject[key];
			}
		}
		return data;
	}

	function getReportTable()
	{
			var reportTable = document.createElement('table');
			reportTable.setAttribute('class','reporttable');
			reportTable.setAttribute('border','1');			
			return reportTable;
	}
	
	function getTableCellElement(topDocument, text, clazz, colspan, rowspan)
	{
		if (topDocument != null)
		{
			cellElement = topDocument.createElement('td');
		}
		var cellElement = topDocument.createElement('td');
		text = new String(text);		
		var textArray = text.split("\n");		
		if (textArray.length > 1)
		{	
			for (var i=0;i<textArray.length;i++)
			{				
				if (i>0)cellElement.appendChild(topDocument.createElement('br'));
				cellElement.appendChild(topDocument.createTextNode(textArray[i]));
			}			
		}
		else
		{
			cellElement.appendChild(topDocument.createTextNode(text));
		}
		cellElement.setAttribute('class', clazz);
		if (colspan != null) cellElement.setAttribute('colspan', colspan);
		if (rowspan != null) cellElement.setAttribute('rowspan', rowspan);
		
		return cellElement;
	}
	
	/**
	 *	addHyphensToDateStr()
	 *
	 *	Adds hyphens to date string in yyyymmdd format to
	 *	get yyyy-mm-dd format. If input string already contains
	 *	hyphen(s), the input string is returned unchanged.
	 *	If input string is null or empty, '????-??-??' is returned.
	 *
	 *	@param dateStr String Input date string in yyyy-mm-dd or yyyymmdd format.
	 *	@return String Date string in yyyy-mm-dd format.
	 */
	function addHyphensToDateString(dateStr)
	{
		var dateWithHyphensStr = '????-??-??';
		if (dateStr != null && dateStr != '')
		{
			// Check if input string already contains hyphen
			if (dateStr.indexOf("-") >= 0)
			{
				// Date already has hyphen(s)
				dateWithHyphensStr = dateStr;
			}
			else
			{
				// Date in yyyymmdd format
				var yearStr = dateStr.substr(0,4);
				var monthStr = dateStr.substr(4,2);
				var dayStr = dateStr.substr(6,2);			
				dateWithHyphensStr = yearStr + '-' + monthStr + '-' + dayStr;
			}
		}
		return dateWithHyphensStr;
	}

	/**
	 *	dateStrToDate()
	 *
	 *	Takes an input date string in yyyy-mm-dd or yyyymmdd format
	 *	and returns a date corresponding to the date string.
	 *	If input string is null or empty, null is returned.
	 *
	 *	@param dateStr String Input date string in yyyy-mm-dd or yyyymmdd format.
	 *	@return Date Date corresponding to input date string.
	 */
	function dateStrToDate(dateStr)
	{
		var date = null;
		if (dateStr != null && dateStr != '')
		{
			// Check if input string already contains hyphen
			if (dateStr.indexOf("-") >= 0)
			{
				// Date in yyyy-mm-dd format
				var yearStr = dateStr.substr(0,4);
				var monthStr = dateStr.substr(5,2);
				var dayStr = dateStr.substr(8,2);			
				var date = new Date(parseInt(yearStr, 10), parseInt(monthStr, 10)-1, parseInt(dayStr, 10));
			}
			else
			{
				// Date in yyyymmdd format
				var yearStr = dateStr.substr(0,4);
				var monthStr = dateStr.substr(4,2);
				var dayStr = dateStr.substr(6,2);			
				var date = new Date(parseInt(yearStr, 10), parseInt(monthStr, 10)-1, parseInt(dayStr, 10));
			}
		}
		return date;
	}

	function goPrint()
	{
		var printNote = '<b>Note!</b> For better printing set page orientation to <i>portrait</i>.';
		printNote += ' Scale down to <i>90%</i> to fit 2 plots per page.';
		openPrintWindow('<%=ID%>', 'reportcell', 'Lab environment ', 'portrait', printNote, '../');
	}
	
	var xGuide;
	var yGuide;
	
	function drawCanvasGuidelines(event)
	{
		if (!xGuide)
		{
			xGuide = document.getElementById('x-guide');
			yGuide = document.getElementById('y-guide');
		}
		var canvas = event.target;
		var centerX = event.clientX;
		var centerY = event.clientY;
		var canvasPos = Main.getElementPosition(canvas);
		var startX = canvasPos.left+50;
		var widthX = canvasPos.width-100;
		var startY = canvasPos.top+80;
		var heightY = canvasPos.height-160;
		if (centerY < startY || centerY > startY+heightY)
		{
			// Hide when mouse is in the text area below or over the plot
			yGuide.style.display = 'none';
		}
		else
		{
			yGuide.style.top = (centerY-2) + 'px';
			yGuide.style.left = startX + 'px';
			yGuide.style.width = widthX + 'px';
			yGuide.style.display = 'block';
		}
		if (centerX < startX || centerX > startX + widthX)
		{
			// Hide when mouse is in the text area to the left or right of the plot
			xGuide.style.display = 'none';
		}
		else
		{
			// Avoid drawing outside the avilable hight (causes an extra pair of scroll bars)
			var yLimit = Main.getWindowHeight();
			if (startY+heightY > yLimit)
			{
				heightY = yLimit-startY;
			}
			xGuide.style.top = startY + 'px';
			xGuide.style.left = (centerX-2) + 'px';
			xGuide.style.height = heightY + 'px';
			xGuide.style.display = 'block';
		}

	}
	
	function hideCanvasGuidelines(event)
	{
		xGuide.style.display = 'none';
		yGuide.style.display = 'none';
	}
	</script>
	
	<style>
	canvas
	{
		width: 700px;
		height: 550px;
	}
	</style>
	<base:body onload="init()">
		<p:path><p:pathelement 
			title="" href="<%="./labenvironmentdatabaseeventpopup.jsp?ID="+ID%>" 
			/><p:pathelement id="pageTitleId" title="Lab environment event display"
			/></p:path>
		<div id="x-guide" style="position: absolute; z-index: 99; display: none; background-color: #224488; width: 1px;"></div>
		<div id="y-guide" style="position: absolute; z-index: 99; display: none; background-color: #224488; height: 1px;"></div>
		<div class="content">
	
		<form name="labenv" onsubmit="return false;">
			<div id="reportSection" style="display:block;">
				<p></p>
				<table border="0" cellspacing="0" cellpadding="0">
				<tr>
					<td id="reportcell">
						<div id="reportdiv" style="text-align: center;">
							<div class="loading" id="loading">
							<table>
							<tr>
								<td><img src="../images/loading.gif"></td>
								<td id="loading.msg">Generating report...</td>
							</tr>
							</table>
							</div>
						</div>
					</td>
				</tr>
				</table>
			</div>	
		</form>
		</div>

	<base:buttongroup subclass="dialogbuttons">
		<base:button onclick="goPrint();" image="<%=home+"/images/print.png"%>" title="Print&hellip;" />
		<base:button onclick="window.close();" title="Cancel" />	
	</base:buttongroup>

	</base:body>
	</base:page>
	<%
}
finally
{
	if (dc != null) dc.close();
}
%>